-- If you're upgrading from a previous pastebin package, just run the bottom portion. 
-- If this is your first pastebin installation, run the whole thing
-- You might need to change credentials and such


--Create databse in MySQL
CREATE database pastebin;


-- Create a user for Pastebin
grant all privileges on pastebin.* to 'pastebin'@'localhost' identified by 'banjo';
flush privileges;

-- Use pastebin database
use pastebin;

--Create table in MySQL
CREATE TABLE `pastebin` (
   `pid` int(11) NOT NULL auto_increment,
   `poster` varchar(16) default NULL,
   `posted` datetime default NULL,
   `code` text,
   `parent_pid` int(11) default '0',
   `format` varchar(16) default NULL,
   `codefmt` mediumtext,
   `codecss` text,
   `domain` varchar(255) default '',
   `expires` DATETIME,
   `expiry_flag` ENUM('d','m', 'f') NOT NULL DEFAULT 'm',
   PRIMARY KEY  (`pid`),
   KEY `domain` (`domain`)
   );

-- If you are upgrading from the previous package (pastebin-0.50-x) , run the following
-- Create table in MySQL
create table recent
(
        domain varchar(255),
        pid int not null,
        seq_no int not null,
        primary key(domain,seq_no)
);

-- Also part of the upgrade
ALTER TABLE pastebin
        ADD COLUMN expires DATETIME,
        ADD COLUMN expiry_flag ENUM('d','m', 'f') NOT NULL DEFAULT 'm';

UPDATE pastebin SET expires=DATE_ADD(posted, INTERVAL 1 MONTH) where expires is null and expiry_flag='m';

